using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

namespace Dialogs
{
	public class LoanApplicationHelp : Dialogs.LoanApplicationToolTip
	{
		//private System.ComponentModel.IContainer components = null;

		public LoanApplicationHelp()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Name = "label1";
			// 
			// applicantNameTextBox
			// 
			this.applicantNameTextBox.Name = "applicantNameTextBox";
			// 
			// okButton
			// 
			this.okButton.Name = "okButton";
			// 
			// cancelButton
			// 
			this.cancelButton.Name = "cancelButton";
			// 
			// label2
			// 
			this.label2.Name = "label2";
			// 
			// label3
			// 
			this.label3.Name = "label3";
			// 
			// applicantPhoneNoTextBox
			// 
			this.applicantPhoneNoTextBox.Name = "applicantPhoneNoTextBox";
			// 
			// applicantLoanAmountTextBox
			// 
			this.applicantLoanAmountTextBox.Name = "applicantLoanAmountTextBox";
			// 
			// groupBox1
			// 
			this.groupBox1.Name = "groupBox1";
			// 
			// buttonApply
			// 
			this.buttonApply.Name = "buttonApply";
			// 
			// LoanApplicationHelp
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 190);
			this.HelpButton = true;
			this.Name = "LoanApplicationHelp";
			this.HelpRequested += new System.Windows.Forms.HelpEventHandler(this.LoanApplicationHelp_HelpRequested);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		// Retrieve all controls and all child controls and etc.
		// Make sure to send controls back at lowest depth first
		// so that most child controls are checked for things before
		// container controls, e.g. a TextBox is checked before a
		// GroupBox control
		protected Control[] GetAllControls() 
		{
			ArrayList list = new ArrayList();
			GetAllControls(Controls, list);
			return (Control[])list.ToArray(typeof(Control));
		}
		protected void GetAllControls(Control.ControlCollection controls, ArrayList list) 
		{
			foreach(Control control in controls) 
			{
				if(control.HasChildren) GetAllControls(control.Controls, list);
				list.Add(control);
			}
		}

		private void LoanApplicationHelp_HelpRequested(object sender, System.Windows.Forms.HelpEventArgs hlpevent)
		{
			if (Control.MouseButtons == MouseButtons.None) 
			{
				string subtopic = null;
				if (this.ActiveControl == this.applicantNameTextBox) 
				{
					subtopic = "name";
				} 
				else if (this.ActiveControl == this.applicantPhoneNoTextBox) 
				{
					subtopic = "phone";
				} 
				else if (this.ActiveControl == this.applicantLoanAmountTextBox)
				{
					subtopic = "loanAmount";
				}
				Help.ShowHelp(this, @"H:\cop4226\05f\ch3\Dialogs\Loan.chm", "LoanApplication.htm#" + subtopic);
				
			} 
			else 
			{
				Point pt = this.PointToClient(hlpevent.MousePos);
				Control controlHelp = null;
				foreach( Control control in GetAllControls()) 
				{
					if( control.Bounds.Contains(pt) ) 
					{
						controlHelp = control;
						break;
					}
				}
				if (controlHelp != null) 
				{
					String help = toolTip1.GetToolTip(controlHelp);
					if (help.Length > 0) 
					{
						Help.ShowPopup(this, help, hlpevent.MousePos);
						hlpevent.Handled = true;
					}
				}
			}
		}
	}
}

